#!/usr/bin/perl -w

use strict;
use URI::URL;

my $mp3list = 'playlist.m3u';
my $mp3dir  = '/path/to/music';
my $mp3url  = 'http://some.server.com/path/to/music';
my $mp3re   = qr/\.mp3$/i;
my @mp3s   = ();

print "Recursively searching in $mp3dir\n";
search($mp3dir);
print "Found: " . scalar(@mp3s) . " matches\n";

print "Writing playlist to $mp3list\n";
open (M3U,">$mp3list");
foreach my $mp3 (@mp3s) {
	$mp3 =~ s#^$mp3dir#$mp3url#;
	my $mp3_url = URI::URL->new($mp3);
	print M3U $mp3_url->as_string,"\n";
}
close (M3U);
print "Done.\n";

# Recursively search for MP3 files
sub search {
	my ($path) = @_;

	my @files = ();
	opendir (DIR, "$path");
	@files = readdir(DIR);
	closedir(DIR);

	foreach my $file (sort @files) {
		next if ($file =~ m/^\.{1,2}$/);
		my $fullpath = $path . '/' . $file;
		if (-d $fullpath) {
			search($fullpath);
		}
		elsif (-f $fullpath) {
			if ($file =~ $mp3re) {
				push @mp3s, $fullpath;
			}
		}
	}
}
